% DCT_IV by means of DFT

% R. Gluth, "Regular FFT-related transform kernels for DCT/DST based polyphase
% filter banks", IEEE ICASSP, vol.3, pp,2205-2208, 1991.

% signal to be transformed
N=16;
x=randn(1,N);

% original DCT matrix
DCT4=cos(pi/N*[(0:N-1)+1/2]'*[(0:N-1)+1/2]);

% true result
y=x*DCT4

%%% algorithm %%%
u=x(1:2:end)+j*x(N:-2:1);
p=u.*exp(-j*pi/N*((0:N/2-1)+1/8));
P=fft(p);
v=P.*exp(-j*pi/N*((0:N/2-1)+1/8));

y1=zeros(1,length(x));
y1(1:2:end)=real(v);
y1(N:-2:1)=-imag(v);
y1
