% DCT_I by means of DCT_II

% Markus P?schel, Jos? MF Moura. The Algebraic Approach to the Discrete
% Cosine and Sine Transforms and their Fast Algorithms SIAM Journal of
% Computing 2003, Vol. 32, No. 5, pp. 1280-1316.


% signal to be transformed
N=16;
k=0:N-1;
x=randn(1,N+1);

% original DCT_I matrix
DCT1=cos(pi/N*[(0:N)]'*[(0:N)]);

% true result
y=x*DCT1

% DST_II matrix
DST2=sin(pi/N*[(0:N-1)+1]'*[(0:N-1)+1/2]);

%%% algorithm %%%
D=diag(1./[1 sin((k+1)*pi/(2*N))]);
B=diag(ones(1,N),-1)-eye(N+1);
B(1,:)=2;B(2,1)=2;B(end,end)=-2;
B=B/2;

y1=x*D*[1 zeros(1,N); zeros(N,1) DST2]*B


