% DST_III by means of DCT_IV

% Markus P?schel, Jos? MF Moura. The Algebraic Approach to the Discrete
% Cosine and Sine Transforms and their Fast Algorithms SIAM Journal of
% Computing 2003, Vol. 32, No. 5, pp. 1280-1316.


% signal to be transformed
N=16;
x=randn(1,N);

% original DST_III matrix
S=sin(pi/N*[(0:N-1)+1/2]'*[(0:N-1)+1]);

% true result
y=x*S


%%% algorithm (1st method) %%%
u=x.*(sin(pi/N*((0:N-1)+1/2))./cos(pi/2/N*((0:N-1)+1/2)));

DCTIV=cos(pi/N*[(0:N-1)+1/2]'*[(0:N-1)+1/2]);
p=u*DCTIV;

B=triu(ones(N));

y1=p*B

return

%%% algorithm (2nd method) %%%
u=x.*((-1).^(0:N-1));
u=u.*(1./(cos(pi/2/N*((0:N-1)+1/2))));

DCTIV=cos(pi/N*[(0:N-1)+1/2]'*[(0:N-1)+1/2]);
p=u*DCTIV;

B=diag(ones(1,N))+diag(ones(1,N-1),1);
B(1,1)=2;
B=B/2;
p=p*B;

y1=fliplr(p)
