% DST_I by means of DST_II

% Markus P?schel, Jos? MF Moura. The Algebraic Approach to the Discrete
% Cosine and Sine Transforms and their Fast Algorithms SIAM Journal of
% Computing 2003, Vol. 32, No. 5, pp. 1280-1316.


% signal to be transformed
N=16;
k=0:N-1;
x=randn(1,N-1);

% original DST_I matrix
DST1=sin(pi/N*[(0:N-2)+1]'*[(0:N-2)+1]);

% true result
y=x*DST1

% DST_II matrix
DST2=sin(pi/N*[(0:N-1)+1]'*[(0:N-1)+1/2]);

%%% algorithm %%%
D=diag(sin((k+1)*pi/N)./sin((k+1)*pi/(2*N)));
B=inv(eye(N)+diag(ones(1,N-1),1));

y1=[x 0]*D*DST2*B;
y1=y1(1:end-1)


